import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_business {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '内容' })
  'content': string = undefined;
  @ApiProperty({ description: '收费标准' })
  'money': string = undefined;
  @ApiProperty({ description: '收费依据' })
  'basic': string = undefined;
  @ApiProperty({ description: '邮费' })
  'postage': string = undefined;
  @ApiProperty({ description: '所需材料' })
  'material': Array<any> = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_business extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = ['name', 'type', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '名称' })
  'name': string = undefined;
  @ApiProperty({ description: '类型' })
  'type': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_business extends FVO_business {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_business {
  @ApiProperty({ description: '名称' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '内容' })
  @Rule(RuleType['string']().empty(''))
  'content': string = undefined;
  @ApiProperty({ description: '收费标准' })
  @Rule(RuleType['string']().empty(''))
  'money': string = undefined;
  @ApiProperty({ description: '收费依据' })
  @Rule(RuleType['string']().empty(''))
  'basic': string = undefined;
  @ApiProperty({ description: '邮费' })
  @Rule(RuleType['string']().empty(''))
  'postage': string = undefined;
  @ApiProperty({ description: '所需材料' })
  @Rule(RuleType['array']().empty(''))
  'material': Array<any> = undefined;
  @ApiProperty({ description: '类型' })
  @Rule(RuleType['string']().empty(''))
  'type': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_business extends FVO_business {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_business extends CDTO_business {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_business extends FVO_business {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
