import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_personnel {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: '头像' })
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '出生年月' })
  'birth': string = undefined;
  @ApiProperty({ description: '学历' })
  'education': string = undefined;
  @ApiProperty({ description: '专业' })
  'speciality': string = undefined;
  @ApiProperty({ description: '职务' })
  'zw': string = undefined;
  @ApiProperty({ description: '职称' })
  'zc': string = undefined;
  @ApiProperty({ description: '执业证号' })
  'number': string = undefined;
  @ApiProperty({ description: '工作经历' })
  'work': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QDTO_personnel extends SearchBase {
  constructor() {
    const like_prop = ['name'];
    const props = ['gender', 'is_use'];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
  @ApiProperty({ description: '姓名' })
  'name': string = undefined;
  @ApiProperty({ description: '性别' })
  'gender': string = undefined;
  @ApiProperty({ description: '是否使用' })
  'is_use': string = undefined;
}

export class QVO_personnel extends FVO_personnel {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_personnel {
  @ApiProperty({ description: '头像' })
  @Rule(RuleType['array']().empty(''))
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '姓名' })
  @Rule(RuleType['string']().empty(''))
  'name': string = undefined;
  @ApiProperty({ description: '性别' })
  @Rule(RuleType['string']().empty(''))
  'gender': string = undefined;
  @ApiProperty({ description: '出生年月' })
  @Rule(RuleType['string']().empty(''))
  'birth': string = undefined;
  @ApiProperty({ description: '学历' })
  @Rule(RuleType['string']().empty(''))
  'education': string = undefined;
  @ApiProperty({ description: '专业' })
  @Rule(RuleType['string']().empty(''))
  'speciality': string = undefined;
  @ApiProperty({ description: '职务' })
  @Rule(RuleType['string']().empty(''))
  'zw': string = undefined;
  @ApiProperty({ description: '职称' })
  @Rule(RuleType['string']().empty(''))
  'zc': string = undefined;
  @ApiProperty({ description: '执业证号' })
  @Rule(RuleType['string']().empty(''))
  'number': string = undefined;
  @ApiProperty({ description: '工作经历' })
  @Rule(RuleType['array']().empty(''))
  'work': Array<any> = undefined;
  @ApiProperty({ description: '简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '是否使用' })
  @Rule(RuleType['string']().empty(''))
  'is_use': string = undefined;
}

export class CVO_personnel extends FVO_personnel {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_personnel extends CDTO_personnel {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_personnel extends FVO_personnel {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
