import { Rule, RuleType } from '@midwayjs/validate';
import { ApiProperty } from '@midwayjs/swagger';
import { SearchBase } from 'free-midway-component';
import get = require('lodash/get');
const dealVO = (cla, data) => {
  for (const key in cla) {
    const val = get(data, key);
    if (val || val === 0) cla[key] = val;
  }
};
export class FVO_config {
  constructor(data: object) {
    dealVO(this, data);
  }
  @ApiProperty({ description: '数据id' })
  _id: string = undefined;
  @ApiProperty({ description: 'logo' })
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '首页轮播图' })
  'file': Array<any> = undefined;
  @ApiProperty({ description: '联系电话' })
  'phone': string = undefined;
  @ApiProperty({ description: '邮箱' })
  'email': string = undefined;
  @ApiProperty({ description: '地址' })
  'address': string = undefined;
  @ApiProperty({ description: '工作时间' })
  'time': string = undefined;
  @ApiProperty({ description: '平台简介' })
  'brief': string = undefined;
  @ApiProperty({ description: '办证须知' })
  'notice': string = undefined;
  @ApiProperty({ description: '用户协议' })
  'agreement': string = undefined;
}

export class QDTO_config extends SearchBase {
  constructor() {
    const like_prop = [];
    const props = [];
    const mapping = [];
    super({ like_prop, props, mapping });
  }
}

export class QVO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class CDTO_config {
  @ApiProperty({ description: 'logo' })
  @Rule(RuleType['array']().empty(''))
  'logo': Array<any> = undefined;
  @ApiProperty({ description: '首页轮播图' })
  @Rule(RuleType['array']().empty(''))
  'file': Array<any> = undefined;
  @ApiProperty({ description: '联系电话' })
  @Rule(RuleType['string']().empty(''))
  'phone': string = undefined;
  @ApiProperty({ description: '邮箱' })
  @Rule(RuleType['string']().empty(''))
  'email': string = undefined;
  @ApiProperty({ description: '地址' })
  @Rule(RuleType['string']().empty(''))
  'address': string = undefined;
  @ApiProperty({ description: '工作时间' })
  @Rule(RuleType['string']().empty(''))
  'time': string = undefined;
  @ApiProperty({ description: '平台简介' })
  @Rule(RuleType['string']().empty(''))
  'brief': string = undefined;
  @ApiProperty({ description: '办证须知' })
  @Rule(RuleType['string']().empty(''))
  'notice': string = undefined;
  @ApiProperty({ description: '用户协议' })
  @Rule(RuleType['string']().empty(''))
  'agreement': string = undefined;
}

export class CVO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}

export class UDTO_config extends CDTO_config {
  @ApiProperty({ description: '数据id' })
  @Rule(RuleType['string']().empty(''))
  _id: string = undefined;
}

export class UVAO_config extends FVO_config {
  constructor(data: object) {
    super(data);
    dealVO(this, data);
  }
}
