import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { FrameworkErrorEnum, ServiceError, BaseService } from 'free-midway-component';
import { Chat } from '../../entity/core/chat.entity';
type modelType = ReturnModelType<typeof Chat>;
@Provide()
export class ChatService extends BaseService<modelType> {
  @InjectEntityModel(Chat)
  model: modelType;

  // 该用户全部已读
  async read(filter) {
    const { user } = filter;
    if (!user) throw new ServiceError('没有用户信息!', FrameworkErrorEnum.NOT_FOUND_DATA);
    const list: any = await this.model.find({ user, speaker: user, is_read: '0' }).lean();
    const chat = list.map(i => {
      return i._id;
    });
    for (const val of chat) {
      await this.model.updateOne({ _id: val }, { is_read: '1' });
    }
    return 'ok';
  }
}
