import { Provide } from '@midwayjs/decorator';
import { InjectEntityModel } from '@midwayjs/typegoose';
import { ReturnModelType } from '@typegoose/typegoose';
import { BaseService } from 'free-midway-component';
import { User } from '../../entity/system/user.entity';
import { Chat } from '../../entity/core/chat.entity';
import { Types } from 'mongoose';
const ObjectId = Types.ObjectId;
type modelType = ReturnModelType<typeof User>;
@Provide()
export class UserService extends BaseService<modelType> {
  @InjectEntityModel(User)
  model: modelType;

  @InjectEntityModel(Chat)
  chatModel: ReturnModelType<typeof Chat>;

  async user(filter) {
    const { skip = 0, limit, ...info } = filter;
    const list: any = await this.model.find(info).skip(skip).limit(limit).lean();
    const total = await this.model.count(info);
    for (const val of list) {
      const result = await this.chatModel
        .find({
          user: new ObjectId(val._id).toString(),
          speaker: new ObjectId(val._id).toString(),
          is_read: '0',
        })
        .lean();
      if (result.length > 0) val.is_read = '未读';
      else val.is_read = '已读';
    }
    return { list, total };
  }
}
